#ifndef __EEPROM_H_
#define __EEPROM_H_
#include "sys.h"


/*Define ISP/IAP/EEPROM command*/
#define CMD_IDLE    0               //Stand-By
#define CMD_READ    1               //u8-Read
#define CMD_PROGRAM 2               //u8-Program
#define CMD_ERASE   3               //Sector-Erase

/*Define ISP/IAP/EEPROM operation const for IAP_CONTR*/
//#define ENABLE_IAP 0x80           //if SYSCLK<30MHz
//#define ENABLE_IAP 0x81           //if SYSCLK<24MHz
#define ENABLE_IAP  0x82            //if SYSCLK<20MHz
//#define ENABLE_IAP 0x83           //if SYSCLK<12MHz
//#define ENABLE_IAP 0x84           //if SYSCLK<6MHz
//#define ENABLE_IAP 0x85           //if SYSCLK<3MHz
//#define ENABLE_IAP 0x86           //if SYSCLK<2MHz
//#define ENABLE_IAP 0x87           //if SYSCLK<1MHz
//stc12c2052ad    10K EEPROM 
#define e_addr_1  0x0000 //ʼַ/512ֽ
#define e_addr_2  0x0200 //ʼַ/512ֽ
#define e_addr_3  0x0400 //ʼַ/512ֽ
#define e_addr_4  0x0600 //ʼַ/512ֽ
#define e_addr_5  0x0800 //ʼַ/512ֽ
#define e_addr_6  0x0A00 //ʼַ/512ֽ
#define e_addr_7  0x0C00 //ʼַ/512ֽ
#define e_addr_8  0x0E00 //ʼַ/512ֽ
#define e_addr_9  0x1000 //ʼַ/512ֽ
#define e_addr_10 0x1200 //ʼַ/512ֽ
#define e_addr_11 0x1400 //ʼַ/512ֽ
#define e_addr_12 0x1600 //ʼַ/512ֽ
#define e_addr_13 0x1800 //ʼַ/512ֽ
#define e_addr_14 0x1A00 //ʼַ/512ֽ
#define e_addr_15 0x1C00 //ʼַ/512ֽ
#define e_addr_16 0x1E00 //ʼַ/512ֽ
#define e_addr_17 0x2000 //ʼַ/512ֽ
#define e_addr_18 0x2200 //ʼַ/512ֽ
#define e_addr_19 0x2400 //ʼַ/512ֽ
#define e_addr_20 0x2600 //ʼַ/512ֽ

void IapIdle();
u8 eeprom_r(u16 addr);
void eeprom_w(u16 addr, u8 dat);
void eeprom_e(u16 addr);

#endif